<?php

// получение данных из бд
function db_out($db,$settings){

	$sql = $db->query("SELECT id, alt_name, xfields FROM ". PREFIX ."_post");
	$out = array();

	while ( $row = $db->get_row( $sql ) ) {
		$out['id'][]       = $row['id'];
		$out['alt_name'][] = $row['alt_name'];
		$xfields  = xfieldsdataload($row['xfields']);
		$out['xfields_idkp'][] = $xfields[$settings['kpid_name']];	
		$out['xfields_waid'][] = $xfields[$settings['waid_name']];
	}
	$db->free( $sql );
	return $out;
}

// проверка GET параметров
function getValue ($val, $two = false){
	if(!empty($_GET[$val])) $val = $_GET[$val];
	else $val = $two;
	return $val;
}

// тип видео для url
function typeMovies ($category){
    $movies_array = array('movies', 'camrip', 'russian', 'anime');
    if (in_array($category, $movies_array)) $type = 'movies';
    else $type = 'serials';
	return $type;
}


// хвост для url api
function plusUrl ($category){
    if ($category == 'movies')        $plus_url = '';       
    if ($category == 'camrip')        $plus_url = '&category=CamRip';      
    if ($category == 'russian')       $plus_url = '&category=Russian';     
    if ($category == 'anime')         $plus_url = '&category=Anime';
    if ($category == 'serials')       $plus_url = '';
	if ($category == 'ru_serials')    $plus_url = '&category=Russian';
    if ($category == 'anime_serials') $plus_url = '&category=Anime';
	if ($category == 'ukraine')       $plus_url = '';
	if ($category == 'block')         $plus_url = '';
	return $plus_url;
}


/**
*
*	Подсчет строк для вывода постанично, возвращает массив: start - finish
*	Параметры: 1 - текущий номер страницы, 2 - кол-во строк в массиве, 3 - сколько строк выводить на странице
*
*/
function rowsCulc ($page, $n_array, $rows = 50) {

	$result = array();
	if ($page < 2 || $page == false)
	{
		$start = 0;
		$finish = $start + $rows;
		$finish = ($n_array < $finish) ? $n_array : $rows;
	}
	else 
	{			
		$start = ($page - 1) * $rows;
		$finish = $start + $rows;
		$finish = ($n_array < $finish) ? $n_array : $finish ;
	}
	$result['start']  = $start;
	$result['finish'] = $finish;
	return $result;
}


// URL-ы для получения данных по API 
function urlAPI ($arr){
	$url = '';
	$sistemos_api_key = 'efseHEhdhuwHw32esHEe';
	
	/*
		Списки для вкладок "Блокировки" и "Сериалы (украинский язык)" модуль получает с сайта sistemos.ru, 
		они обновляются по крону 1 раз в сутки. Так как таких чистых списков из JSON-фидов у мунволка нет.

		Все остальные списки (вкладка Камрипы, Зарубежные, Русские, Аниме, Сериалы, Сериалы (RU), Аниме Сериалы) 
		модуль получает сразу напрямую с JSON-фида обновлений мунвалка. 
		Они модулем не кэшируются и актуальны в момент открытия соответствующей вкладки.	
	*/
	
	if ($arr['category'] == 'ukraine') 
		//$url = 'http://moonwalk.cc/api/serials_foreign.json?api_token='.$arr['api_token'].$arr['plus_url'];
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=serials_ua';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'camrip') 
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=camrip';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'films_ru') 
		//$url = 'http://moonwalk.cc/api/movies_russian.json?api_token='.$arr['api_token'];	
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=films_ru';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'films_en') 
		//$url = 'http://moonwalk.cc/api/movies_foreign.json?api_token='.$arr['api_token'];
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=films_en';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'serials') 
		//$url = 'http://moonwalk.cc/api/serials_foreign.json?api_token='.$arr['api_token'];
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=serials_en';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'serials_ru') 
		//$url = 'http://moonwalk.cc/api/serials_russian.json?api_token='.$arr['api_token'];
		$url = 'https://sistemos.ru/api/json.php?api_key='.$sistemos_api_key.'&catblock=serials_ru';
    else 
    	$url = 'http://moonwalk.cc/api/'.$arr['type'].'_updates.json?api_token='.$arr['api_token'].$arr['plus_url'].'&page='.$arr['page'];	

    return $url;
}


// проверка существования актуального кэша
function contentCache ($url,$settings){
	
	// если данные таба кэшируются
	if ( in_array($settings['category'], $settings['cat_cache']) ) {
		
		// получаю последние значение из get-строки (кроме page), чтобы использовать для имении файла кэша
		$query = parse_url($_SERVER['REQUEST_URI']);
		parse_str($query['query'], $arr_url);		
		unset($arr_url['page']); 
		if (count($arr_url) < 3 ) $cache_name = end($arr_url);
		else $cache_name = end($arr_url) . '_' . $settings['category'];

		// уточняю названия файлов
		if ($cache_name == 'serials_block') $cache_name = 'serials_en';
		if ($cache_name == 'ukraine')       $cache_name = 'serials_ua';

		// если есть актуальный файл в кэше, то считываю
		if ( issetCacheFile($cache_name) ) {
			$content_obj = fileExObj (ENGINE_DIR . '/inc/moonbase/cache/'.$cache_name.'.txt');
			return $content_obj;			
		} 
		// иначе парсинг напрямую и запись в файл
		else {
			$content_obj = parsURL ($url);
			$content_str = serialize($content_obj);
			file_put_contents(ENGINE_DIR.'/inc/moonbase/cache/'.$cache_name.'.txt',  $content_str);			
			return $content_obj;
		}
	} 
	// иначе парсинг напрямую
	else 
		$content_obj = parsURL ($url);

	return $content_obj;
}



// парсинг контента
function parsURL ($url){
    if ( $curl = curl_init() ) {
       curl_setopt($curl, CURLOPT_URL, $url);
       curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
       curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
       curl_setopt($curl, CURLOPT_ENCODING, "");
       curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 6);
       curl_setopt($curl, CURLOPT_TIMEOUT, 20);
       curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
       curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
       curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
       $output = curl_exec($curl);
       $content  = json_decode($output);
       curl_close($curl);
    } else $content = json_decode(file_get_contents($url));	
    return $content;
}

function myPrint ($mass){
	echo '<pre>';
	print_r($mass);
	echo '</pre>';
}

// Проверка на существование файла и проверка его на возраст
function issetCacheFile ($file_name) {
	$res = false;
	$chekfile = ENGINE_DIR . '/inc/moonbase/cache/'.$file_name.'.txt';
	// если файл существует и больше 20 байт
	if( file_exists ($chekfile) AND filesize($chekfile) > 20) {
		// чекаю на возраст на актуальность
		$age = fileAge ($chekfile);
		if ($age) $res = true;	
	}
	return $res;
}

// актуальный возраст файла, если старше - не актуальный
function fileAge ($chekfile, $interval = 12) {
	$timeout = $interval * 60 * 60; // 12 часов
	$file_date = @filemtime($chekfile);
	$file_date = time()-$file_date;	
	$buffer = ( $file_date >  $timeout ) ? false : true;
	return $buffer;
}

// Если файл есть, то читает и возвращает массив, иначе возвращает пустой массив
function fileExObj ($path_file){
	$mass = array();    
	if( file_exists ($path_file) ){
	  $id_str = file_get_contents($path_file);
	  $mass = unserialize($id_str);
	}
	return $mass;   
}

// смена кодировки, если не utf-8
function myIconv ($val,$config){
	$charset = ( strtolower($config['charset']) != 'utf-8' ) ? true : false;
	if ($charset) $val = iconv('utf-8', 'windows-1251//IGNORE', $val);
	return $val;
}


//===============================================================================
//=====                                        ==================================
//=====       Для вывода данных в таблицы      ==================================												
//=====                                        ==================================
//===============================================================================

// вывод данных в таблицу для вкладки UA
function showTableUA ($content, $settings, $bufer = false){
	
	// если не из sistemos json
	if (!$bufer) $content = $content->{'report'}->serials;
	
	$nSerials = count ($content); // количество сериалов в api json	
	$nFilmBD  = $settings['n_film_bd'];                // количество новостей в базе сайта
	$serials  = array();
	
	$i = 0;
	// Отбираю в массив сериалы с украинским переводом (имеет id 103)
    for ( $m=0; $m < $nSerials; $m++ ){
		if ( $content[$m]->{'translator_id'} == 103 ) {
			$serials['title_ru'][$i]       = myIconv ($content[$m]->title_ru, $settings['config']); // автосмена кодировки, если не utf-8
			$serials['title_clear'][$i]    = $serials['title_ru'][$i]; 
			$serials['title_en'][$i]       = $content[$m]->title_en;		
			$serials['year'][$i]           = $content[$m]->year;
			$serials['idkp'][$i]           = $content[$m]->kinopoisk_id;
			$serials['seasons_count'][$i]  = $content[$m]->seasons_count;
			$serials['episodes_count'][$i] = $content[$m]->episodes_count;
			$serials['iframe_url'][$i]     = iconIframe ($content[$m]->iframe_url);
			$serials['block'][$i]          = block_cauntry($content[$m]->block);
			$serials['blocked_at'][$i]     = $content[$m]->block->blocked_at;
			$serials['info'][$i]           = materialDatePars ($content[$m], true);
			$i++;
		}
    }
   
	$n_serials = count ($serials['idkp']);		
	$serials_have = array();
	 
	// Получаю сериалы, которые есть в базе
    for ( $m=0; $m < $n_serials; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
		  
         $kp_id_moon_s = $serials['idkp'][$m];
		 $serials['edit'][$m] = '';
		 $serials['have'][$m] = iconCheck ('no');
		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields_idkp'][$i] == $kp_id_moon_s AND $kp_id_moon_s !== NULL ) {
			
			$serials['title_ru'][$m] = iconLink  ($i,$serials['title_ru'][$m],$settings,'R');
			$serials['title_en'][$m] = iconLink  ($i,$serials['title_en'][$m],$settings,'E');
			$serials['edit'][$m]     = iconEdit  ($settings['out']['id'][$i],$settings);
			$serials['have'][$m]     = iconCheck ('yes');
			
			break;
         }
      }
    }
	
	return $serials;
}


// данные для вкладки Блокировки Сериалы
function showTableBlockS ($content, $settings, $bufer = false){
	
	// если не из sistemos json
	if (!$bufer) $content = $content->{'report'}->serials;
	
	$nSerials = count ($content);        // количество сериалов в api json
	$nFilmBD  = $settings['n_film_bd'];   // количество новостей в базе сайта
	$kinopoisk_id_m = '';
	$ArrBlockS = array();
	$i = 0;
	// Отбираю в массив заблокированные сериалы
	for ( $m=0; $m < $nSerials; $m++ ){

		$block_obj = $content[$m]->block;
		$block = block_cauntry ($block_obj);
		
		if ($block) {
			if ($kinopoisk_id_m != $content[$m]->kinopoisk_id ) {
				$ArrBlockS[$i]['title_ru']       = myIconv ( $content[$m]->title_ru, $settings['config'] );
				$ArrBlockS[$i]['title_clear']    = $ArrBlockS[$i]['title_ru'];   
				$ArrBlockS[$i]['title_en']       = $content[$m]->title_en;
				$ArrBlockS[$i]['year']           = $content[$m]->year;
				$ArrBlockS[$i]['idkp']           = $content[$m]->kinopoisk_id;
				$ArrBlockS[$i]['seasons_count']  = $content[$m]->seasons_count;
				$ArrBlockS[$i]['episodes_count'] = $content[$m]->episodes_count;
				$ArrBlockS[$i]['iframe_url']     = iconIframe ( $content[$m]->iframe_url );
				$ArrBlockS[$i]['block']          = $block;
				$ArrBlockS[$i]['blocked_at']     = $content[$m]->block->blocked_at;
				$ArrBlockS[$i]['have']           = iconCheck ('no');
				$ArrBlockS[$i]['info']           = materialDatePars ($content[$m], true);
				$i++;
			}
		}
		
		// для отбора в массив только уникальных сериалов (без повторений с разными переводами)
		$kinopoisk_id_m = $content[$m]->{'kinopoisk_id'};
	}
	
    $nBlock  = count ($ArrBlockS);
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    for ( $m=0; $m < $nBlock; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $ArrBlockS[$m]['idkp'];			 		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields_idkp'][$i] == $kp_id_moon AND $kp_id_moon !== NULL ) {

			$ArrBlockS[$m]['title_ru'] = iconLink  ($i,$ArrBlockS[$m]['title_ru'],$settings,'R');
			$ArrBlockS[$m]['title_en'] = iconLink  ($i,$ArrBlockS[$m]['title_en'],$settings,'E');		
            $ArrBlockS[$m]['edit']     = iconEdit  ($settings['out']['id'][$i],$settings);
			$ArrBlockS[$m]['have']     = iconCheck ('yes');

             break;
         }
      }
    }
	
	// сортировка массива по убыванию даты в blocked_at
	usort($ArrBlockS, 'mysort' );

	return $ArrBlockS;
}

// сортировка массива по значению blocked_at
function mysort($a,$b) { return $a['blocked_at'] < $b['blocked_at'];}

// данные для вкладки Блокировки Фильмы
function showTableBlockF ($content, $settings, $bufer = false){

	// если не из sistemos json
	if (!$bufer) $content->{'report'}->movies;	

	$nFilmsApi      = count ($content);         // количество фильмов в api json
	$nFilmBD        = $settings['n_film_bd'];   // количество новостей в базе сайта
	$kinopoisk_id_m = '';
	$ArrBlockF      = array();

	// Отбираю в массив заблокированные фильмы
	$i = 0;
	for ( $m=0; $m < $nFilmsApi; $m++ ){
		
		$block_obj = $content[$m]->block;
		$block = block_cauntry ($block_obj);

		if ($block) {
			$ArrBlockF[$i]['title_ru']       = myIconv ($content[$m]->title_ru, $settings['config']);
			$ArrBlockF[$i]['title_clear']	 = $ArrBlockF[$i]['title_ru'];
			$ArrBlockF[$i]['title_en']       = $content[$m]->title_en;
			$ArrBlockF[$i]['idkp']           = $content[$m]->kinopoisk_id;
			$ArrBlockF[$i]['year']           = $content[$m]->year;
			$ArrBlockF[$i]['source_type']    = ($content[$m]->source_type) ? $content[$m]->source_type : 'HDRip';
			$ArrBlockF[$i]['iframe_url']     = iconIframe ( $content[$m]->iframe_url );
			$ArrBlockF[$i]['block']          = $block;
			$ArrBlockF[$i]['blocked_at']     = $content[$m]->block->blocked_at;
			$ArrBlockF[$i]['have']           = iconCheck ('no');
			$ArrBlockF[$i]['info']           = materialDatePars ($content[$m]);
			$i++;
		}
		
	}

    $nBlock  = count ($ArrBlockF);
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    for ( $m=0; $m < $nBlock; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $ArrBlockF[$m]['idkp'];			 		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields_idkp'][$i] == $kp_id_moon AND $kp_id_moon !== NULL ) {

			$ArrBlockF[$m]['title_ru'] = iconLink  ($i,$ArrBlockF[$m]['title_ru'],$settings,'R');
			$ArrBlockF[$m]['title_en'] = iconLink  ($i,$ArrBlockF[$m]['title_en'],$settings,'E');		
            $ArrBlockF[$m]['edit']     = iconEdit  ($settings['out']['id'][$i],$settings);
			$ArrBlockF[$m]['have']     = iconCheck ('yes');

             break;
         }
      }
    }
	
	// сортировка массива по убыванию даты в blocked_at
	usort($ArrBlockF, 'mysort' );
		
	return $ArrBlockF;

}

// вывод данных в таблицу (для камрипов, зарубежных, аниме, сериалов, аниме сериалов)
function showTableDefault ($content, $settings){
		
    $nFilmApi = count ($content->{'updates'}); // количество фильмов с page api

	// получаю фильмы, которые есть в базе
    $films_mass_have = massHave ($content, $settings);

	$mass_pack = array();
	
	for ( $i=0; $i < $nFilmApi; $i++ ){
		// данные из api для фильмов		
        $mass_pack[$i]['date']         = $content->{'updates'}[$i]->added_at;
        $mass_pack[$i]['iframe_link']  = $content->{'updates'}[$i]->iframe_url;
        $mass_pack[$i]['idkp']         = $content->{'updates'}[$i]->kinopoisk_id;
		$mass_pack[$i]['world_art_id'] = $content->{'updates'}[$i]->world_art_id;
        $mass_pack[$i]['title_ru']     = $content->{'updates'}[$i]->title_ru;
        $mass_pack[$i]['title_en']     = $content->{'updates'}[$i]->title_en;
		$mass_pack[$i]['year']         = $content->{'updates'}[$i]->year;
		$mass_pack[$i]['instream_ads'] = $content->{'updates'}[$i]->instream_ads;
		$mass_pack[$i]['source_type']  = $content->{'updates'}[$i]->source_type;				
        $mass_pack[$i]['translator']   = $content->{'updates'}[$i]->translator;
        $mass_pack[$i]['block']        = $content->{'updates'}[$i]->block;
		$mass_pack[$i]['info']         = materialDatePars ($content->{'updates'}[$i]);
		
		// для сериалов
        if ($settings['type'] == 'serials') {
            $mass_pack[$i]['idkp']           = $content->{'updates'}[$i]->{'serial'}->kinopoisk_id;
			$mass_pack[$i]['world_art_id']   = $content->{'updates'}[$i]->{'serial'}->world_art_id;
            $mass_pack[$i]['title_ru']       = $content->{'updates'}[$i]->{'serial'}->title_ru;
            $mass_pack[$i]['title_en']       = $content->{'updates'}[$i]->{'serial'}->title_en;
			$mass_pack[$i]['year']           = $content->{'updates'}[$i]->{'serial'}->year;
			$mass_pack[$i]['instream_ads']   = $content->{'updates'}[$i]->{'serial'}->instream_ads;
            $mass_pack[$i]['iframe_link']    = $content->{'updates'}[$i]->{'serial'}->iframe_url;
            $mass_pack[$i]['translator']     = $content->{'updates'}[$i]->{'serial'}->translator;
			$mass_pack[$i]['seasons_count']  = $content->{'updates'}[$i]->{'serial'}->seasons_count;
			$mass_pack[$i]['episodes_count'] = $content->{'updates'}[$i]->{'serial'}->episodes_count;			
			$mass_pack[$i]['block']          = $content->{'updates'}[$i]->{'serial'}->block;
			$mass_pack[$i]['info']           = materialDatePars ($content->{'updates'}[$i]->serial, true);
        }
		
		// смена кодировки, если требуется
		$mass_pack[$i]['title_ru']      = myIconv ($mass_pack[$i]['title_ru'], $settings['config']);
		$mass_pack[$i]['translator']    = myIconv ($mass_pack[$i]['translator'], $settings['config']);	
		
		// чистое название для всех фильмов, независимо от наличия в бд
		$mass_pack[$i]['title_clear']   = $mass_pack[$i]['title_ru'];		
		
		// Значения качества по-умолчанию для категорий с камрипами и hd
		if ($settings['category'] == 'camrip' && !$mass_pack[$i]['source_type']) 
			$mass_pack[$i]['source_type'] = 'CAMRip';
		if ($settings['category'] == 'movies' || $settings['category'] == 'russian' AND !$mass_pack[$i]['source_type']) 
			$mass_pack[$i]['source_type'] = 'HDRip';		
		
	
		
		// доп данные
		$mass_pack[$i]['info_true']     = $settings['info_true'];
		$mass_pack[$i]['type']          = $settings['type'];
		$mass_pack[$i]['category']      = $settings['category'];						
		
		$mass_pack[$i]['edit']          = '';
		$mass_pack[$i]['idbd']          = '';
		$mass_pack[$i]['link']          = '';
		
		// данные для фильмов, которые есть в базе
		if ($films_mass_have['have'][$i] == '1') { 
			$mass_pack[$i]['have']     = iconCheck ('yes');
			$mass_pack[$i]['title_ru'] = '<a href="'.$films_mass_have['link'][$i].'" target="_blank" data-original-title="Перейти на страницу с материалом" class="status-info tip">'.$mass_pack[$i]['title_ru'].'</a>';
			$mass_pack[$i]['title_en'] = '<a href="'.$films_mass_have['link'][$i].'" target="_blank" class="status-info tip">'.$mass_pack[$i]['title_en'].'</a>';
			$mass_pack[$i]['edit']     = iconEdit ($films_mass_have['idbd'][$i],$settings);
		}
		else {
			$mass_pack[$i]['have'] = iconCheck ('no');
		}	

		// * - наличие назойливой рекламы
		if ($mass_pack[$i]['instream_ads']) $mass_pack[$i]['instream_ads'] = '*';
						
		// данные о блокировке по гео
		$mass_pack[$i]['block']   = block_cauntry($mass_pack[$i]['block']);		
		
        $mass_pack[$i]['iframe_link'] = iconIframe ($mass_pack[$i]['iframe_link']);	
    }
	
	// убираю повторяющиеся строчки для зарубежных сериалов
	if ($settings['type'] == 'serials')
		$mass_pack = dublStrSerials ($mass_pack);
	
	return $mass_pack;	
}


// убирает повторяющиеся строчки для зарубежных сериалов
function dublStrSerials ($mass_pack) {
	// количество новостей
	$n = count ($mass_pack); 

	$kinopoisk_id_m = '';
	$mass_pack_filter = array();
	$i = 0;
	// Отбираю в массив заблокированные сериалы
	for ( $m=0; $m < $n; $m++ ){
		
		if ($kinopoisk_id_m != $mass_pack[$m]['idkp']) {
			$mass_pack_filter[$i] = $mass_pack[$m];
			$i++;
		}		
		// для отбора в массив только уникальных сериалов (без повторений с разными переводами)
		$kinopoisk_id_m = $mass_pack[$m]['idkp'];
	}
	
	return $mass_pack_filter;	
}


// отбираются в отдельной массив фильмы, или сериалы, которые есть в базе
function massHave ($content, $settings){
	
    $nFilmKP = count ($content->{'updates'});    // количество фильмов с page api
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    $films_mass_have = array();
	
    for ( $m=0; $m < $nFilmKP; $m++ ){
        for ( $i=0; $i < $nFilmBD; $i++ ){
		  
            $kp_id_moon = $content->{'updates'}[$m]->{'kinopoisk_id'};
			$world_art_chek = false;
			
            if ($settings['category'] == 'serials' || $settings['category'] == 'ru_serials' || $settings['category'] == 'anime_serials') 
				$kp_id_moon = $content->{'updates'}[$m]->{'serial'}->kinopoisk_id;
		 
			// если категория аниме и аниме сериалов, то дополнительно проверяю совпадение по ID World-Art?
			if ($settings['category'] == 'anime_serials' || $settings['category'] == 'anime'){	
				
				// получаю world_art_id из api
				if ($settings['category'] == 'anime')
					$world_art_id = $content->{'updates'}[$m]->world_art_id;

				if ($settings['category'] == 'anime_serials')
					$world_art_id = $content->{'updates'}[$m]->{'serial'}->world_art_id;				
				
				if ( $world_art_id AND $settings['out']['xfields_waid'][$i] ) {
					// сравниваю с world_art_id из доп.поля
					if ( $settings['out']['xfields_waid'][$i] == $world_art_id ) {
						$world_art_chek = true;
					}				
				}
			}		 
		 
            // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
			if ( $settings['out']['xfields_idkp'][$i] == $kp_id_moon AND $kp_id_moon !== NULL OR $world_art_chek) {
				$films_mass_have['have'][$m] = '1';
				$films_mass_have['link'][$m] = '/'.$settings['out']['id'][$i].'-'.$settings['out']['alt_name'][$i].'.html';
				$films_mass_have['idbd'][$m] = $settings['out']['id'][$i];
				 break;
			}
        }
    }
	return $films_mass_have;
}

// данные по блокировкам
function block_cauntry ($block_obj) {

	if ($block_obj->block_ru) $result = 'RU';
	if ($block_obj->block_ua) $result = 'UA';
	if ($block_obj->block_ru && $block_obj->block_ua) $result = 'RU, UA';
	if ($result) $result = '<span class="status-info tip" data-original-title="' . $block_obj->blocked_at . '"><span class="label label-danger">'. $result .'</span></span>';
	return $result;
}

// наличие в бд
function iconCheck ($val = 'no'){
	if($val == 'no')  $icon = '<span class="status-error"><i class="icon-exclamation-sign" style="font-size: 18px;"></i></span>'; 
	if($val == 'yes') $icon = '<span class="status-success"><i class="icon-ok-sign" style="font-size: 18px;"></i></span>';
	return $icon;
}

// edit
function iconEdit ($val,$settings){
	return '<a href="'.$settings['config']['admin_path'].'?mod=editnews&action=editnews&id='.$val.'" target="_blank" data-original-title="Перейти к редактированию" class="status-info tip" ><i class="icon-edit" style="font-size:16px;"></a>';
}

// ссылка для плеера
function iconIframe ($val){
	return '<a href="'.$val.'" target="_blank" data-original-title="Перейти" class="status-info tip" ><i class="icon-link icon-2x" style="color:#4C9ECD;"></i></a>';
}

// ссылка на страницу новости
function iconLink ($i,$title,$settings,$k){
	$link = '/'.$settings['out']['id'][$i].'-'.$settings['out']['alt_name'][$i].'.html';
	if ($k == 'E') $res = '<a href="'.$link.'" target="_blank" class="status-info tip">'.$title.'</a>';
	if ($k == 'R') $res = '<a href="'.$link.'" target="_blank" data-original-title="Перейти на страницу с фильмом" class="status-info tip">'.$title.'</a>';
	return $res;
}

// сборка доп.инфы по фильму
function materialDatePars ($obj_all, $serials = false, $ajax = false){
	
	global $Settings;

	// объект с доп.инфой
	$obj = $obj_all->material_data;
	// наличие рекламы
	$instream_ads = $obj_all->instream_ads;

	$result = false;
  
	$kinopoisk_rating  = $obj->kinopoisk_rating;
	$kinopoisk_votes = $obj->kinopoisk_votes; 
	$imdb_rating = $obj->imdb_rating;
	$imdb_votes = $obj->imdb_votes;
	$age = $obj->age;
	
	// рейтинг кп
	if ($kinopoisk_rating) {
		$r_kp = ($kinopoisk_votes) ? $kinopoisk_rating.' ('.$kinopoisk_votes.')' : $kinopoisk_rating;	
		$result = "<b>Рейтинг КП:</b> $r_kp<br>";
	}
	// рейтинг imdb
	if ($imdb_rating) {
		$r_imdb = ($kinopoisk_votes) ? $imdb_rating.' ('.$imdb_votes.')' : $imdb_rating;	
		$result .= "<b>Рейтинг IMDB:</b> $r_imdb<br>";
	}	
	// возраст	
	if ($age) 
		$result .= "<b>Возраст:</b> $age+<br>";
	
	// страны
	if ($obj->countries) {
		$countries = implode(", ", $obj->countries);
		$countries = myIconv ($countries, $Settings['config']);
		$result .= "<b>Страна:</b> $countries<br>";
	}		
	// жанры
	if ($obj->genres) {
		$genres = implode(", ", $obj->genres);
		$genres = myIconv ($genres, $Settings['config']);
		$result .= "<b>Жанр:</b> $genres<br><br>";
	}
	// актеры
	if ($obj->actors && !$ajax) {
		$actors = implode(", ", $obj->actors);
		$actors = myIconv ($actors, $Settings['config']);
		if ($actors)
			$result .= "<b>Актеры:</b> $actors<br><br>";
	}
	// описание	
    if ($obj->description) {
		$description = myIconv ($obj->description, $Settings['config']);
		$result .= "<b>Описание:</b> <span class=\"size_desc_info\">$description</span>...<br>";
	}	
	// назойливая реклама
	if ($result && !$serials) {
		if ($instream_ads) {
			$result .= "<b>Назойливая реклама:</b> <span style=\"color:red;\">да</span><br>";
		} else {
			$result .= "<b>Назойливая реклама:</b> <span style=\"color:green;\">нет</span><br>";
		}		
	}
	
	$res = ($result) ? $result : 'Нет данных';
	return $res;
}

?>

